import 'dart:developer';
import 'dart:io';
import 'dart:isolate';

import 'package:vm_service/vm_service.dart' as vm_service;
import 'package:vm_service/vm_service_io.dart' as vm_service;

void foo() { }

void bar(Function func) { }

void otherMain(dynamic _) {
  stdin.listen((_) {});
}

Future<void> main() async {
  await Isolate.spawn(otherMain, null, debugName: 'test');
  var serviceInfo = await Service.getInfo();
  var vmService = await vm_service
    .vmServiceConnectUri(serviceInfo.serverUri.replace(scheme: 'ws').toString() + 'ws');
  var vm = await vmService.getVM();
  var isolate = vm.isolates.firstWhere((element) => element.name == 'test');
  var scripts = await vmService.getScripts(isolate.id);
  var scriptRef = scripts.scripts.firstWhere((element) => element.uri.contains('test_test.dart'));
  var script = await vmService.getObject(isolate.id, scriptRef.id) as vm_service.Script;
  var library = await vmService.getObject(isolate.id, script.library.id) as vm_service.Library;
  var fooRef = library.functions.firstWhere((element) => element.name == 'foo');
  var obj = await vmService.getObject(isolate.id, fooRef.id);
  
  // Crash happens here:
  await vmService.invoke(isolate.id, library.id, 'bar', [obj.id]);
}
